<ui:composition xmlns:g="http://www.ihe.net/gazelle"
                xmlns:h="http://java.sun.com/jsf/html"
                xmlns:f="http://java.sun.com/jsf/core"
                xmlns:a4j="http://richfaces.org/a4j"
                xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns:s="http://jboss.org/schema/seam/taglib"
                xmlns:rich="http://richfaces.org/rich"
                xmlns="http://www.w3.org/1999/xhtml" template="/layout/template.xhtml">
    <ui:define name="body">
        <ui:decorate template="_template.xhtml">
            <ui:param name="pageName" value="testCoverage"/>
            <ui:param name="controllerName" value="#{testLinkManager}"/>
            <ui:param name="tabId" value="menuTabs"/>
            <ui:param name="linkEntityFilterDivTitle"
                      value="#{messages['net.ihe.gazelle.assertion-manager.TestFilter']}"/>
            <ui:define name="linkEntityFilterDiv">
                <ui:include src="_testsFilters.xhtml">
                    <ui:param name="bean" value="#{testLinkManager}"/>
                    <ui:param name="refreshOnChange" value="testsForm,idSchemesForm"/>
                </ui:include>
            </ui:define>
            <ui:define name="idSchemeFilterPanel">
                <ui:include src="_assertionsFilters.xhtml">
                    <ui:param name="filterParam" value="#{testLinkManager.filter}"/>
                    <ui:param name="idSchemeIdToRefresh" value="idSchemesForm,menuTabs"/>
                </ui:include>
            </ui:define>
            <ui:define name="linkingEntityFold">
                <div class="col-md-5">
                    <h:form id="testsForm">
                        <s:decorate template="/layout/panels/_panel_title.xhtml">
                            <ui:define name="panel_title">
                                <h:outputText
                                        value="#{testLinkManager.tests.size} filtered tests"/>
                            </ui:define>

                            <rich:dataTable rows="20" id="idTests" var="test"
                                            value="#{testLinkManager.tests}" render="idTestsDs">

                                <g:column sortBy="#{'keyword'}">
                                    <ui:define name="header">
                                        #{messages['net.ihe.gazelle.assertion-manager.TestsKeyword']}
                                    </ui:define>
                                    <h:outputText value="#{test.keyword}"
                                                  style="#{testLinkManager.getSelectedTest().getId() == test.getId() ? 'font-weight:bold;' : ''}"/>
                                </g:column>
                                <g:column>
                                    <ui:define name="header">#{messages['net.ihe.gazelle.assertion-manager.Covered']}
                                    </ui:define>
                                    <h:outputText
                                            value="#{testLinkManager.isTestDirectlyCovered(test.id)}"/>
                                </g:column>
                                <g:column>
                                    <a4j:commandLink
                                            value="#{messages['net.ihe.gazelle.assertion-manager.Select']}"
                                            immdediate="true"
                                            actionListener="#{testLinkManager.setSelectedTest(test)}"
                                            render="description,idSchemesForm,testsForm,ruleCoverage"/>
                                </g:column>
                                <f:facet name="footer">
                                    <ui:include src="/util/datatableFooter.xhtml">
                                        <ui:param name="dataScrollerId" value="idTestsDs"/>
                                        <ui:param name="dataTableId" value="idTests"/>
                                        <ui:param name="hideRowsSelect" value="true"/>
                                        <ui:param name="maxPages" value="5"/>
                                    </ui:include>
                                </f:facet>
                            </rich:dataTable>
                        </s:decorate>
                        <ui:decorate template="/layout/panels/_panel_title.xhtml">
                            <ui:define name="panel_title">
                                #{messages['net.ihe.gazelle.assertion-manager.ThisTest']}
                                (#{testLinkManager.getSelectedTest().getKeyword()})
                                #{messages['net.ihe.gazelle.assertion-manager.IsLinkedToThoseAssertions']}
                            </ui:define>
                            <rich:dataTable rows="20" id="ruleCoverage"
                                            var="assertionCoverage"
                                            rendered="#{testLinkManager.isTestSelected()}"
                                            value="#{testLinkManager.assertionsOfSelectedTest()}">
                                <g:column id="action">
                                    <a4j:commandButton styleClass="btn-sm gzl-btn-red"
                                                       rendered="#{testLinkManager.isSelectedTestLinkedTo(assertionCoverage.assertion.id)}"
                                                       actionListener="#{testLinkManager.unlinkSelectedTestFrom(assertionCoverage.assertion.id)}"
                                                       immdediate="true"
                                                       value="#{messages['net.ihe.gazelle.assertion-manager.Unlink']}"
                                                       render="action,testsForm,idSchemesForm"/>
                                </g:column>
                                <g:column
                                        sortBy="#{assertionCoverage.assertion.target.idScheme}"
                                        sortOrder="ascending">
                                    <ui:define name="header">
                                        #{messages['net.ihe.gazelle.assertion-manager.SelectIdScheme']}
                                    </ui:define>
                                    <a4j:commandLink immdediate="true"
                                                     value="#{assertionCoverage.assertion.target.idScheme}"
                                                     actionListener="#{testLinkManager.setSelectedIdScheme(assertionCoverage.assertion.target.idScheme)}"
                                                     render="idSchemesForm,filterform"/>
                                </g:column>
                                <g:column sortBy="#{assertionCoverage.assertion.assertionId}"
                                          sortOrder="ascending">
                                    <ui:define name="header">
                                        #{messages['net.ihe.gazelle.assertion-manager.AssertionId']}
                                    </ui:define>
                                    <h:outputLink id="linkAssertion" target="_assertion"
                                                  title="#{messages['net.ihe.gazelle.assertion-manager.ViewAssertion']}"
                                                  value="#{request.contextPath}/assertions/show.seam">
                                        <f:param name="id" value="#{assertionCoverage.assertion.id}"/>
                                        <h:outputText
                                                value="#{assertionCoverage.assertion.assertionId}"/>
                                    </h:outputLink>
                                </g:column>
                            </rich:dataTable>
                        </ui:decorate>
                    </h:form>
                </div>
                <div class="col-md-7">
                    <h:form id="description">
                        <h:panelGroup rendered="#{testLinkManager.isTestSelected()}">
                            <ui:decorate template="/layout/panels/_panel_title.xhtml">
                                <ui:define name="panel_title">
                                    <h:outputText
                                            value="#{messages['net.ihe.gazelle.assertion-manager.DescriptionOf']} #{testLinkManager.getSelectedTest().getKeyword()} "/>
                                </ui:define>
                                <g:safehtml
                                        value="#{testLinkManager.getSelectedTestDescription()}"/>
                            </ui:decorate>
                        </h:panelGroup>
                    </h:form>
                </div>
            </ui:define>
            <ui:define name="assertionsLinking">
                <h:form id="idSchemesForm">
                    <ui:include src="../_linkAll.xhtml">
                        <ui:param name="manager" value="#{testLinkManager}"/>
                    </ui:include>
                    <rich:dataTable rows="20" id="idScheme" var="assertion"
                                    value="#{testLinkManager.assertions}" render="idSchemeDs">
                        <g:column id="action"
                                  rendered="#{testLinkManager.isTestSelected()}">
                            <a4j:commandButton styleClass="btn-sm gzl-btn-green"
                                               disabled="#{!testLinkManager.isTestSelected()}"
                                               rendered="#{not testLinkManager.isSelectedTestLinkedTo(assertion.id) }"
                                               actionListener="#{testLinkManager.linkSelectedTestTo(assertion.id)}"
                                               immdediate="true"
                                               value="#{messages['net.ihe.gazelle.assertion-manager.LinkTo']}"
                                               render="idSchemesForm,testsForm"/>
                            <a4j:commandButton styleClass="btn-sm gzl-btn-red"
                                               disabled="#{!testLinkManager.isTestSelected()}"
                                               rendered="#{testLinkManager.isSelectedTestLinkedTo(assertion.id)}"
                                               actionListener="#{testLinkManager.unlinkSelectedTestFrom(assertion.id)}"
                                               immdediate="true"
                                               value="#{messages['net.ihe.gazelle.assertion-manager.Unlink']}"
                                               render="idSchemesForm,testsForm"/>
                        </g:column>
                        <ui:include src="../_linkAssertionsTable.xhtml">
                            <ui:param name="assertionParam" value="#{assertion}"/>
                        </ui:include>
                        <f:facet name="footer">
                            <ui:include src="/util/datatableFooter.xhtml">
                                <ui:param name="dataScrollerId" value="idSchemeDs"/>
                                <ui:param name="dataTableId" value="idScheme"/>
                                <ui:param name="hideRowsSelect" value="true"/>
                                <ui:param name="maxPages" value="5"/>
                            </ui:include>
                        </f:facet>
                    </rich:dataTable>
                </h:form>
                <ui:include src="../_linkAllPopup.xhtml">
                    <ui:param name="manager" value="#{testLinkManager}"/>
                    <ui:param name="formToRender" value="testsForm"/>
                </ui:include>
            </ui:define>
        </ui:decorate>
    </ui:define>
</ui:composition>
